
/* GSC38PG317CD14 or something like that.
 *
 * A5 ... A0 are connected,
 * addresses 0x00 ... 0x3F */

#define ASIC PCS0

#define INT_0_REASON ASIC+0x01
#define INT_2_REASON ASIC+0x03

#define UART_0       ASIC+0x04 /* MBUS (echo) */
#define UART_1       ASIC+0x08 /* D25 pins 2,3 */
#define UART_2       ASIC+0x0C /* D25 pins 12,13 */
#define UART_3       ASIC+0x10 /* D25 pins 16,17 */
#define UART_4       ASIC+0x14 /* not connected ? */
#define  UDATA  0
#define  UCTRL  1
#define   B300    0x00
#define   B600    0x01
#define   B1200   0x02
#define   B2400   0x03
#define   B4800   0x04
#define   B9600   0x05
#define   B19200  0x06
#define   B38400  0x07
#define   KUIKKA  0x18 /* 0 no parity, 3 even parity */
#define   KUIRI   0x20 /* 7 databits if set? */
#define   KIURU   0xC0 /* stopbits? 3 no visible effect to tx, mbus rx garble */
#define  USTAT  2      /* framing/parity/overrun/txbf/rxbf/tint/rint */
#define  UIENB  3      /* 2 tint, 1 rint and mystery bits 0x8 and 0x4 */

/* misc TTL and CMOS pins */
#define PA_DDR       ASIC+0x1F /* DDR (0 means input) */
#define PA_DAT       ASIC+0x20 /* data reg. default FE or DA (float?) */
#define PA_CHG       ASIC+0x21 /* changes */
#define PA_IEN       ASIC+0x22 /* IEN */
#define   OFFBUTTON 0x01 /* in  100k pullup and diode to CU #ON/OFF */
#define   BANK      0x02 /* out which half of the 512 kB ram is visible */
#define   D25_5     0x04 /* out via HC14 */
#define   SDA       0x08 /*     smd8/5 */
#define   DISP_ON   0x10 /* out via HC245. 1 = display and backlight on. */
#define   PA_UNK    0x20 /* in  but what ? */
#define   SCL       0x40 /*     smd8/6 */
#define   JUMPER    0x80 /* in  D25/4 XXX extra wire is blocking watchdog */

/* rs232 pins, levelshifted */
#define PB_DDR       ASIC+0x23 /* DDR */
#define PB_DAT       ASIC+0x24 /* data reg. default EA or 2A (float?) */
#define PB_CHG       ASIC+0x25 /* changes */
#define PB_IEN       ASIC+0x26 /* IEN */
#define   D25_6     0x01 /* out */
#define   D25_20    0x02 /* in  */
#define   D25_14    0x04 /* out */
#define   D25_15    0x08 /* in  */
#define   D25_18    0x10 /* out */
#define   D25_21    0x20 /* in  */

#define SERV         ASIC+0x2E /* lsbit is LED "SERV" */
#define BEEP         ASIC+0x2F /* lsbit is D15/12. a beeper. */

#if 0

/* MBUS (and ?) idle/active monitor */
#define ?            ASIC+0x18 /* 0x10 pin, 8 change. out 0x6 delay? 1 ien? */
#define ?            ASIC+0x19 /* read 18, but don't ack int (guess) */


/* keyboard/keypad/barcode reader, int_1 */
#define ?            ASIC+0x1A /* data reg ? */
#define ?            ASIC+0x1B /* 0x40 0x20 8 4 3 (tx control ?) */
#define ?            ASIC+0x1C /* sibling of 1B   (rx control ?) 0x10 flag */
#define ?            ASIC+0x1D /* 1tint 4tie?, 2rint 8rie. 0x20 0x10 dma1? */


/* periodic timer, input clock is XTAL / 16 */
#define ?            ASIC+0x27 /* count msbyte */
#define ?            ASIC+0x28 /* count lsbyte */
#define ?            ASIC+0x29 /* run/int/? 1 2 4 out, interrupted 8 in */


#define ?            ASIC+0x00 /* 1 halves asic input clock */
#define ?            ASIC+0x1E /* 1 keeps chip/? in reset? could be keyboard? */
#define ?            ASIC+0x2A /* 1 rewind watchdog */

#define ?            ASIC+0x2C /* out maybe always 0 or FF. not beeper tone */
#define ?            ASIC+0x2D /* out sibling of 2C.        neither. */

/* 0x02, 0x2B, 0x30...0x3F never used ? read as zero. */

#endif

