
#include "head.h"
#include "pcb.h"
#include "asic.h"

#undef putc

static void
putc(c)
{
	while (inb(UART_1+USTAT) & 8)
		;
	outb(UART_1+UDATA, c);
}

static void
putb(b)
	byte b;
{
	putc(hexdig[b / 16]);
	putc(hexdig[b % 16]);
}

static void
putw(w, sep)
	word w;
{
	putb(w / 256);
	putb(w % 256);
	putc(sep);
}

static void
puts(s)
	byte *s;
{
	while (*s)
		putc(*s++);
}

void
dump(msg, ss, IREGS_)
	char *msg;
{
	word w = sp + 6; /* skip ip cs flags */
	int i;

	puts("\r\n");
	putw(cs, ':'); putw(ip, ' '); putw(flags, ' ');

	putw(ss, ':'); putw(w, ' '); /* ss:sp before exception */
	putw(bp, ' ');
	putw(ds, ' '); putw(es, ' ');
	putw(ax, ' ');
	putw(bx, ' ');
	putw(cx, ' ');
	putw(dx, ' ');
	putw(si, ' ');
	putw(di, ' ');
	puts("\r\n");

	/* dozen or so words from stack, less if it wraps */

	for (i = 0; i < 14; ++i) {
		if ((w & ~1) == 0)
			break;

		putw(peekw(ss, w), ' ');
		w += 2;
	}
	puts("\r\n");

	/* function trace (assuming near calls) */

	w = bp;
	for (i = 0; i < 14; ++i) {

		putw(peekw(ss, w + 2), ' ');
		w = peekw(ss, w);
		if (w == 0)
			break;
	}
	if (msg) {
		puts("\r\n");
		puts(msg);
	}
	puts("\r\n\
cs:ip f ss:sp bp ds es abcd si di, stack, traceback\r\n");

	dump_asic();
	reboot();
}

dump_asic()
{
	int i;
	int n = 0;

	for (i = 0x00; i < 0x40; i++) {
		if (n == 0) {
			putb(i);
			putc(':');
		}
		putc(' ');
		putb(inb(i));

		if (++n >= 16) {
			n = 0;
			puts("\r\n");
		}
	}
	puts("\r\n");
}

