
#include "head.h"
#include "pcb.h"
#include "asic.h"
#include "keys.h"

struct file *filee = &Uart_1;

static void
silly()
{
#include "logo.wqx"

	graphics_on();

	draw_box(0x155, 0,0, 320,240);
	draw_box(0x211, 8,8, 304,224);

	draw_pic(logo_bits,
		(320 - logo_width) / 2, (240 - logo_height) / 2,
		logo_width, logo_height);

#if 0
	byte mask = 1, *p = logo_bits;
	int x, y;

	for (y = 0; y < logo_height; ++y)
		for (x = 0; x < logo_width; ++x) {
			draw_pixel((*p & mask) ? pixel_set : pixel_clr, x, y);

			if (! (mask <<= 1)) { mask = 1; ++p; }
		}
#endif

	graphics_off();
	clear_screen();
}

void
regshow()
{
	byte buf[42];

	sprintf(buf, "%02X  %02X %02X  %02X %02X              ",
		inb(0x19),
		inb(0x1B), inb(0x1C),
		inb(PA_DAT), inb(PB_DAT));

	update_row(0, 8, buf);
}

void
initialise()
{
	outb(BEEP, 1);
	outb(SERV, 0);

	/* misc TTL and CMOS pins */

	outb(PA_DAT, DISP_ON);
	outb(PA_DDR, DISP_ON | BANK | D25_5);
	outb(PA_IEN, 0);

	/* rs232 pins, levelshifted */

	outb(PB_DAT, D25_18 | D25_14);          /* D25_6 at +12v, others -12v */
	outb(PB_DDR, D25_18 | D25_14 | D25_6);
	outb(PB_IEN, D25_20 | D25_15 | D25_21); /* monitor handshake inputs */

	/* keyboard/keypad/barcode reader */

	outb(0x1B, 0x03); /* keyboard config ? 8 disable?, 4 ?, 0-3 5..8bit */
	outb(0x1C, 0x03); /* rx side */
	outb(0x1D, 0x08); /* rienb ? */

	/* serial ports */

	uart_config(UART_0,  B9600); /* MBUS */
	uart_config(UART_1, B19200); /* external, pins 2,3 */
	uart_config(UART_2,  B9600); /* external, pins 12,13 */
	uart_config(UART_3,  B9600); /* external, pins 16,17 */
	uart_config(UART_4,  B9600); /* not connected at all ? */

	/* 18/19 MBUS and ? idle monitor */

	outb(0x18, 0x06 | 1); /* delay value and interrupt enable ? */

	/* asic timer */

	outb(0x27, 0x80); /* 0x8000 timeconstant, about 31 Hz (XTAL/16/count) */
	outb(0x28, 0x00);
	outb(0x29, 0x03); /* run, interrupt ? */

	crt_init();

	outb(BEEP, 0);
	enable();

#if 0
	/* keyboard leds off, ED 00
	 * 0 1011 0111 11 0 0000 0000 11
	 * 0101101111100000000011
	 * 0101 1011 1110 0000 0000 11 */

	outb(0x1A, 0x5B); /* while (inb(0x??) & ?) ; */

	busywait_usec(10000);

	outb(0x1A, 0xE0); /* while (inb(0x??) & ?) ; */

	busywait_usec(10000);

	outb(0x1A, 0x0F); /* two extra bits at end */

	busywait_usec(10000);

	outb(BEEP, 0); busywait_usec(10000);
	outb(BEEP, 1); busywait_usec(10000);
#endif

	silly();

	fprintf(&Screen, "%s\r\n", version + 4);

	if ((inb(PA_DAT) & JUMPER) == 0)
		regenerate();
}

void
XXX_mainloop()
{
	static word osrc;
	word c;

	while ((c = getc_0()) != -1) {
		static char buf[40];
		static int i;

		if (c >= ' ') {
			if (i < 40)
				buf[i++] = c;
		} else {
			if (i) {
				bzero(buf + i, 40 - i);
				i = 0;
				update_row(0, 8, buf);
			}
		}
	}
	while ((c = getc_1()) != -1) {
		if (osrc != '1') {
			osrc = '1';
			fprintf(&Screen, " %c ", osrc);
		}
		(*Screen.putc)(c);
	}
	while ((c = getc_2()) != -1) {
		if (osrc != '2') {
			osrc = '2';
			fprintf(&Screen, " %c ", osrc);
		}
		(*Screen.putc)(c);
	}
	while ((c = getc_3()) != -1) {
		if (osrc != '3') {
			osrc = '3';
			fprintf(&Screen, " %c ", osrc);
		}
		(*Screen.putc)(c);
	}
	while ((c = getc_4()) != -1) {
		if (osrc != '4') {
			osrc = '4';
			fprintf(&Screen, " %c ", osrc);
		}
		(*Screen.putc)(c);
	}
	while ((c = getc_kbd()) != -1) {
		if (osrc != 'k') {
			osrc = 'k';
			fprintf(&Screen, " %c ", osrc);
		}
		(*Screen.putc)(c);
	}
}

void
mainloop()
{
	word c;

	if ((c = (*filee->getc)()) != -1) {
		putc_screen(c);
	} else
		update_cursor();

	if ((c = getc_kbd()) != -1) {
		switch (c) {
		default:
			(*filee->putc)(c);
			break;

		case KF1:
			if (filee == &Mbus) {
				filee = &Uart_1;
				fputs("[1]\n\r", &Screen);
				break;
			}
			if (filee == &Uart_1) {
				filee = &Uart_2;
				fputs("[2]\n\r", &Screen);
				break;
			}
			if (filee == &Uart_2) {
				filee = &Uart_3;
				fputs("[3]\n\r", &Screen);
				break;
			}
			if (filee == &Uart_3) {
				filee = &Uart_4;
				fputs("[4]\n\r", &Screen);
				break;
			}
			filee = &Mbus;
			fputs("[0]\n\r", &Screen);
			break;
		}
	}
}

/* 256 Hz periodic, dma_?_int really */

static word asic_timer_hz;

void
tick(IREGS)
{
	static word otim;
	word r;

#if 0
	regshow();
#endif

	if (otim != timew) {
		otim = timew;

		uart_unwedge();

#if 0
		putc_2('c');
		putc_3('d');
		putc_4('e');
#endif
#if 0
		fprintf(&Screen, " tik%x ", exchangew(0, &asic_timer_hz));
		fprintf(&Screen, " %x %x ", inb(0x00), inb(0x02));

		outb(0x2C, (otim & 1) ? 0xFF : 0);
		outb(0x2D, (otim & 2) ? 0xFF : 0);

		outb(BEEP, (otim >> 3) & 1);
#endif
		outb(SERV, otim & 1);
	}
}

/* nmi, int_0, int_1, int_2 and timer_XXX_int in boot.c */

void
nmi(IREGS)
{
	fputs(" nmi ", &Screen);
}

void
int_3(IREGS)
{
	fputs(" int3 ", &Screen);
}

void
timer_0_int(IREGS)
{
	fputs(" tmr0 ", &Screen);
}

void
timer_1_int(IREGS)
{
	fputs(" tmr1 ", &Screen);
}

void
timer_2_int(IREGS)
{
	fputs(" tmr2 ", &Screen);
}

void
dma_0_int(IREGS)
{
	fputs(" dma0 ", &Screen);
}

void
dma_1_int(IREGS)
{
	fputs(" dma1 ", &Screen);
}

/* changes on PA monitored bits
 * lsbyte is current state,
 * msbyte shows changes */

void
pa_chg(w)
	word w;
{
	fprintf(&Screen, " pa%x ", w);
}

/* changes on PB monitored bits, "rs232 handshake" signals
 * lsbyte is current state,
 * msbyte shows changes */

void
pb_chg(w)
	word w;
{
	fprintf(&Screen, " pb%x ", w);
}

void
asic_timer_int()
{
	asic_timer_hz++;
}

