
/*
 * One file structure is allocated
 * for each open/creat/pipe call.
 * Main use is to hold the read/write
 * pointer associated with each open
 * file.
 */
struct	file
{
	char	f_flag;
	char	f_count;		/* reference count */
	struct inode *f_inode;		/* pointer to inode structure */
	union {
		off_t	f_offset;	/* read/write character pointer */
	} f_un;
};

extern	struct file file[];		/* the file table itself */

struct	file *getf();
struct	file *falloc();

/* file flags, in file[].f_flag */
#define	FREAD	01
#define	FWRITE	02
#define	FAPPEND	04
#define	FNDELAY	010
#define	FMASK	077

#define	FPIPE	0100

/* and some for open(2) only */
#define	FCREAT	0400
#define	FTRUNC	01000
#define	FEXCL	02000 

/* descriptor flags, in u.u_pofile[] */
#define EXCLOSE 1

