
#define	HZ		100		/* Ticks/second of the clock */
#define	NINODE	60		/* number of in core inodes */
#define	NFILE	60		/* number of in core file structures */
#define	NCALL	40		/* max simultaneous time callouts */
#define	NOFILE	20		/* max open files per process */
#define	NPROC	30		/* max number of processes */
#define	NTEXT	NPROC	/* max number of pure texts */

#define	NBUF	50		/* size of buffer cache */
#define	NMOUNT	3		/* number of mountable file systems */
#define	NCLIST	100		/* max total clist size */
#define	NCARGS	512 	/* # characters in exec arglist */

/*
 * priorities
 */

#define	PSWP	0
#define	PINOD	10
#define	PRIBIO	20
#define	PZERO	25
#define	PPIPE	26
#define	PWAIT	30
#define	PSLEP	40
#define	PUSER	50

#define	NZERO	20

/*
 * No more than 16 signals (1-16) because they are
 * stored in bits in a word.
 */
#define	SIGHUP	1	/* hangup */
#define	SIGINT	2	/* interrupt (rubout) */
#define	SIGQUIT	3	/* quit (FS) */
#define	SIGILL	4	/* illegal instruction */
#define	SIGTRAP	5	/* trace or breakpoint */
#define	SIGABRT	6	/* trace or breakpoint */

#define	SIGFPE	8	/* floating exception */
#define	SIGKILL	9	/* kill, uncatchable termination */

#define	SIGSEGV	11	/* segmentation violation */
#define	SIGSYS	12	/* bad system call */
#define	SIGPIPE	13	/* end of pipe */
#define	SIGALRM	14	/* alarm clock */
#define	SIGTERM	15	/* Catchable termination */
#define	NSIG	16
#define sigmask(sig) (1 << ((sig) - 1))

#define SIG_ERR (-1)
#define SIG_DFL 0
#define SIG_IGN 1


#define	NBBY	8		/* number of bits in a byte */
#define	NULL	0
#define VOID (void)
#define __SIZEOF(r) (sizeof(r)/sizeof(*(r)))

#define	NODEV	((dev_t)-1)

#define	SUPERB	((daddr_t)1)	/* block number of the super block */
#define	ROOTINO	((ino_t)2)	/* i number of all roots */
#define	DIRSIZ	14		/* max characters per directory */

#define	NICFREE	100		/* number of superblock free blocks */
#define	NICINOD	46		/* number of superblock inodes */
#define	INOPB	8		/* inodes per block, BSIZE/sizeof(struct dinode) */

#define	BSHIFT	9		/* LOG2(BSIZE) */
#define	BSIZE	512		/* size of disk block (bytes) */
#define	BMASK	(BSIZE-1)

#define	NSHIFT	7		/* LOG2(NINDIR) */
#define	NMASK	(NINDIR-1)
#define	NINDIR	(BSIZE/sizeof(daddr_t))

#define	CBSIZE	28		/* number of chars in a clist block */
#define	CROUND	0x1F		/* clist rounding; sizeof(int *) + CBSIZE -1*/

/* inumber to disk address and inumber to disk block index */
#define	itod(x)	((daddr_t)((((unsigned)(x)+2*INOPB-1)/INOPB)))
#define	itoo(x)	((int)(((x)+2*INOPB-1)%INOPB))

#define	major(x)	((int)(((unsigned)(x)>>8)&0377))
#define	minor(x)	((int)((x)&0377))
#define	makedev(x,y)	((dev_t)(((x)<<8) | (y)))

typedef	unsigned short	u_short;

typedef	unsigned short	ino_t;
typedef	short	dev_t;

typedef	char *	caddr_t;
typedef	short	size_t;

typedef	long	daddr_t;
typedef	long	off_t;
typedef	long	time_t;

struct timeval { long tv_sec, tv_usec; };

#define	MAXTSIZ	4095	/* max text size in paragraphs */
#define	MAXDSIZ	4095	/* max data ... */

#define btop(n) (((n) + 15) >> 4)
#define ptob(p) ((long) (p) << 4)

