
struct user {
	off_t	u_offset;		/* i/o offset in file */
	u_short	u_count;		/* i/o bytes remaining */
	caddr_t	u_base;			/* i/o base address */
	char	u_segflg;		/* u_base in 0: kernel D, 1: user D, 2: user I */
	char	u_avail;

	char	u_pofile[NOFILE];	/* per-process flags of open files */
	struct	file *u_ofile[NOFILE];	/* file structures of open files */

	struct	inode *u_pdir;		/* inode of parent directory from namei() */
	struct	direct u_dent;		/* current directory entry */
	char	u_dbuf[DIRSIZ];		/* current pathname component */
};

/*
 * One structure allocated per active process.
 * It contains all data needed about the process.
 */
struct proc {
	struct	proc *p_link;	/* run/sleep list */

	struct	proc *p_parent;

	int	p_flag;
	char	p_stat;
	char	p_pri;		/* priority, negative is high */
	char	p_nice;		/* nice for cpu usage */
	char	p_cpu;		/* cpu usage for scheduling */

	short	p_pid;		/* unique process id */
	short	p_pgrp;		/* pid of process group leader */
	short	p_sig;		/* signals pending to this process */

	struct	inode *p_cdir;		/* current directory */
	struct	inode *p_ctty;		/* controlling tty */

	caddr_t p_wchan;	/* event process is awaiting */
	short	p_clktim;	/* time to alarm clock signal */
#define p_xstat p_clktim

	struct	text *p_textp;
	short	p_ds, p_dsize;
	short	p_sp, p_ss;		/* context in user */
	short	p_ksp;			/* context in system */

	short	p_signal[NSIG];		/* disposition of signals */

	struct user p_user;

	char	p_stack[342];
};

#define u (curproc->p_user)

extern struct proc
	proc[],		/* the proc table itself */
	*runq,		/* pointer to linked list of running processes */
	*curproc;

#define proc_init (&proc[0])

/* stat one of */
#define	SZOMB	1		/* intermediate state in process termination */
#define	SIDL	2		/* intermediate state in process creation */
#define	SSLEEP	3		/* awaiting an event */
#define	SRUN	4		/* running */

/* flag mix of */
#define	SLOAD	0x01		/* in core */
#define	SSYS	0x02		/* system process */
#define	SWEXIT	0x04		/* working on exiting */
#define	SKEEP	0x08		/* must not swap */

