
#include "../h/param.h"
#include "../h/systm.h"
#include "../h/dir.h"
#include "../h/buf.h"
#include "../h/proc.h"

/* 256 kB, 2nd ram bank */
#define RDSIZE 0x40000L
#define RDBASE 0x20000L

struct buf
	rdtab,
	rdrbuf;

rdstrategy(bp)
	register struct buf *bp;
{
	if (minor(bp->b_dev) != 0
	 || bp->b_blkno < 0
	 || bp->b_blkno >= RDSIZE / BSIZE
	 || bp->b_bcount % BSIZE) {
		bp->b_flags |= B_ERROR;
		iodone(bp);
		return;
	}
	bp->av_forw = NULL;

	rddoit(bp);
}

rdread(dev, f_flag)
	register dev;
{
	physio(rdstrategy, &rdrbuf, dev, B_READ, minphys);
}

rdwrite(dev, f_flag)
	register dev;
{
	physio(rdstrategy, &rdrbuf, dev, B_WRITE, minphys);
}

rddoit(bp)
	register struct buf *bp;
{
	unsigned long baddr, count, eoff;

	eoff = bp->b_blkno << BSHIFT;

	count = bp->b_bcount;
	if (count > RDSIZE - eoff)
		count = RDSIZE - eoff;

	baddr = bp->b_un.b_addr;
	if (bp->b_flags & B_PHYS)
		baddr += ptob(bp->b_proc->p_ds);

	bank(1);

	if (bp->b_flags & B_READ) {
		far_bcopy(RDBASE + eoff, baddr, count);
	} else {
		far_bcopy(baddr, RDBASE + eoff, count);
	}
	bank(0);

	bp->b_resid = bp->b_bcount - count;
	iodone(bp);
}

