
#include "../h/param.h"
#include "../h/systm.h"
#include "../h/errno.h"
#include "../h/map.h"
#include "../h/dir.h"
#include "../h/proc.h"
#include "../h/inode.h"
#include "../h/buf.h"
#include "../h/text.h"
#include "../h/exec.h"

xalloc(ip, ex)
	struct inode *ip;
	struct exec *ex;
{
	register struct text *xp;
	struct text *xp1;

	xp1 = NULL;
	for (xp = text; xp < &text[NTEXT]; xp++) {
		if (xp->x_inode == NULL) {
			xp1 = xp;
			continue;
		}
		if (xp->x_inode == ip) {
			xlock(xp);
			xp->x_count++;
			curproc->p_textp = xp;
			xunlock(xp);
			if ((xp->x_flag&XLOAD) == 0)
				goto argh;
			return;
		}
	}
	if ((xp = xp1) == NULL) {
argh:
		psignal(curproc, SIGKILL);
		return;
	}

	xp->x_inode = ip;
	xp->x_count = 1;
	xp->x_flag = XLOCK;
	xp->x_csize = ex->ex_tsize;
	xp->x_cs = malloc(coremap, xp->x_csize);
	curproc->p_textp = xp;

	ip->i_flag |= ITEXT;
	ip->i_count++;

	u.u_offset = sizeof(*ex);
	u.u_count = ptob(xp->x_csize);
	u.u_base = 0;
	u.u_segflg = 2;
	readi(ip, 0);

	xp->x_flag |= XLOAD;
	xunlock(xp);
}

xfree(xp)
	register struct text *xp;
{
	struct inode *ip;

	if (--xp->x_count == 0) {
		xp->x_flag = 0;
		ip = xp->x_inode;
		xp->x_inode = NULL;

		mfree(coremap, xp->x_csize, xp->x_cs);

		ip->i_flag &= ~ITEXT;
		if (ip->i_flag & ILOCK)
			ip->i_count--;
		else
			iput(ip);
	}
}

xlock(xp)
	register struct text *xp;
{
	while (xp->x_flag & XLOCK) {
		xp->x_flag |= XWANT;
		sleep(xp, PSWP);
	}
	xp->x_flag |= XLOCK;
}

xunlock(xp)
	register struct text *xp;
{
	if (xp->x_flag & XWANT)
		wakeup(xp);

	xp->x_flag &= ~(XLOCK|XWANT);
}

