
#include "../h/param.h"
#include "../h/systm.h"
#include "../h/errno.h"
#include "../h/dir.h"
#include "../h/proc.h"
#include "../h/trap.h"
#include "../h/reg.h"

extern long (*sysent[])();

trap(type)
	unsigned type;
{
	int sig, *sp = curproc->p_sp;

	switch (type) {

	default:
		goto nosig;

	case RESOPFLT:	/* invalid instruction */
		sig = SIGILL;
		break;

	case ARITHTRAP: /* divide by zero */
		sig = SIGFPE;
		break;

	case SEGFLT: /* bounds check */
		sig = SIGSEGV;
		break;

	case TRCTRAP:	/* trace trap */
		suword(&sp[FL], fuword(&sp[FL]) & ~FL_TF); /* single step off */

	case BPTFLT:	/* breakpoint */
		sig = SIGTRAP;
		break;
	}
	psignal(curproc, sig);
nosig:
	if (issig())
		psig();

	curpri = setpri(curproc);
	if (runrun)
		qswtch();
}

syscall(code)
	unsigned code;
{
	int *sp = curproc->p_sp + FL + 2;
	long ret;
	int arg[4];

	errno = 0;
	if (code == 0)
		code = fuword(sp++);

	if (code >= nsysent)
		errno = ENOSYS;
	else {
		copyin(sp, arg, sizeof(arg));

		ret = (*sysent[code])(arg[0], arg[1], arg[2], arg[3]);
	}
	sp = curproc->p_sp;
	if (errno) {
		suword(&sp[AX], errno);
		suword(&sp[FL], FL_USER | FL_C);
	} else {
		suword(&sp[AX], ((unsigned *) &ret)[0]);
		suword(&sp[DX], ((unsigned *) &ret)[1]);
		suword(&sp[FL], FL_USER);
	}
	if (issig())
		psig();

	curpri = setpri(curproc);
	if (runrun)
		qswtch();
}

