
#define VERSION "@(#)AD1200F 081026#28 256kB"

typedef unsigned char  byte;
typedef unsigned short word;
typedef unsigned long  dword;
typedef word jmp_buf[16];

#define XTAL   16257000
/* one measured at 16259.4 */

#define CPUCLK (XTAL   / 2)
#define TMRCLK (CPUCLK / 4)

#define HZ     128
#define NOFILE 20

/*
 * LCS  none
 * MCS0 128 kB: 64 kB code/data/bss/stack, upper 64 kB unused
 * MCS1 128 kB: unused
 * MCS2 128 kB: unused
 * MCS3 128 kB: 64 kB display ram
 * UCS  256 kB: rom (could be 128, 256 or 512)
 */
#define SCREEN 0x6000

#if 0
#define RAM0   0x0000 /* 128 kB ram */
#define RAM1   0x2000 /* 512 kB ram (split to 2 banks) */
#define ROM    0x8000
#define ROM    0xC000
#define ROM    0xE000
#endif

/* interrupt or exception
 * pusha
 * push ds
 * push es */

struct iregs {
	word es,ds, di,si,bp,sp,bx,dx,cx,ax, ip,cs,flags;
};

#define IREGS_ES 0
#define IREGS_DS 2
#define IREGS_DI 4
#define IREGS_SI 6
#define IREGS_BP 8
#define IREGS_SP 10   /* ignored by popa */
#define IREGS_BX 12
#define IREGS_DX 14
#define IREGS_CX 16
#define IREGS_AX 18
#define IREGS_IP 20
#define IREGS_CS 22
#define IREGS_FL 24
#define IREGS_SZ 26

#define _P(args) ()

extern void
	outb _P((word port, byte)),
	outw_pcb _P((word port, word)),
	disable _P((void)),
	enable _P((void)),
	splx _P((word opri)),
	pokeb _P((word seg, word offs, byte)),
	pokew _P((word seg, word offs, word)),
	busywait_usec _P((word));              /* max 15 msec */

extern byte
	peekb _P((word seg, word offs)),
	exchangeb _P((byte new, byte *where));

extern word
	inw _P((word port)),
	inb _P((word port)),
	spl_up _P((word npri)),
	peekw _P((word seg, word offs)),
	exchangew _P((word new, word *where));

extern dword
	linear_address _P((word seg, word offset)),
	scale  _P((dword, word)),
	log2   _P((dword)),
	log2p1 _P((dword));

#define spl7() spl_up(7) /* accept priorities 0-7 (all) */
#define spl6() spl_up(6)
#define spl5() spl_up(5)
#define spl4() spl_up(4)
#define spl3() spl_up(3)
#define spl2() spl_up(2)
#define spl1() spl_up(1)
#define spl0() spl_up(0) /* accept only priority 0 */

extern byte
	version[],
	revbits[],
	hexdig[];

extern word
	fido,
	timef,
	timew;

extern dword
	time();

#define _isspace(c) ((int) (c) <= ' ')
#define _isdigit(c) (((word) (c) - '0') <= 9)

#define __SIZEOF(v) (sizeof(v) / sizeof(*(v)))
#define NULL 0

void
	putc_screen(),
	putc_0(),
	putc_1(),
	putc_2(),
	putc_3(),
	putc_4();

int
	getc_kbd(),
	getc_0(),
	getc_1(),
	getc_2(),
	getc_3(),
	getc_4();

extern
struct file {
	void (*putc) _P((byte, struct file *));
	int  (*getc) _P((struct file *));
}
	Uart_1,
	Uart_2,
	Uart_3,
	Uart_4,
	Mbus,
	Screen,
	*filee;

extern void
	draw_pic   _P((wqx_bits, x,y, width,height)),
	draw_box   _P((pattern, x,y, width,height)),
	draw_line  _P(((*pixel_op)(), x,y, x,y)),
	draw_pixel _P(((*pixel_op)(), x,y)),

	pixel_set(), /* pixel_xxx not to be called directly */
	pixel_clr(),
	pixel_flip(),
	pixel_dots_01(),
	pixel_dots_10();

