
#include "head.h"
#include "pcb.h"
#include "asic.h"
#include "keys.h"
#include "task.h"

struct file *filee = &Uart_1;

void *malloc(), *mallocp = malloc;

static void
silly()
{
#include "logo.wqx"

	graphics_on();

	draw_box(0x155, 0,0, 320,240);
	draw_box(0x211, 8,8, 304,224);

	draw_pic(logo_bits,
		(320 - logo_width) / 2, (240 - logo_height) / 2,
		logo_width, logo_height);

#if 0
	byte mask = 1, *p = logo_bits;
	int x, y;

	for (y = 0; y < logo_height; ++y)
		for (x = 0; x < logo_width; ++x) {
			draw_pixel((*p & mask) ? pixel_set : pixel_clr, x, y);

			if (! (mask <<= 1)) { mask = 1; ++p; }
		}
#endif

	graphics_off();
	clear_screen();
}

void
initialise()
{
	outb(BEEP, 1);
	outb(SERV, 0);

	/* misc TTL and CMOS pins */

	outb(PA_DAT, DISP_ON);
	outb(PA_DDR, DISP_ON | BANK | D25_5);
	outb(PA_IEN, 0);

	/* rs232 pins, levelshifted */

	outb(PB_DAT, D25_18 | D25_14);          /* D25_6 at +12v, others -12v */
	outb(PB_DDR, D25_18 | D25_14 | D25_6);
	outb(PB_IEN, D25_20 | D25_15 | D25_21); /* monitor handshake inputs */

	/* keyboard/keypad/barcode reader */

	outb(0x1B, 0x03); /* keyboard config ? 8 disable?, 4 ?, 0-3 5..8bit */
	outb(0x1C, 0x03); /* rx side */
	outb(0x1D, 0x08); /* rienb ? */

	crt_init();

	/* serial ports */

	uart_config(UART_0,  B9600); /* MBUS */
	uart_config(UART_1, B19200); /* external, pins 2,3 */
	uart_config(UART_2,  B9600); /* external, pins 12,13 */
	uart_config(UART_3,  B9600); /* external, pins 16,17 */
	uart_config(UART_4,  B9600); /* not connected at all ? */

	/* 18/19 MBUS and ? idle monitor */

	outb(0x18, 0x06 | 1); /* delay value and interrupt enable ? */

	/* asic timer */

	outb(0x27, 0x80); /* 0x8000 timeconstant, about 31 Hz (XTAL/16/count) */
	outb(0x28, 0x00);
	outb(0x29, 0x03); /* run, interrupt ? */

	outb(BEEP, 0);
	enable();

#if 0
	/* keyboard leds off, ED 00
	 * 0 1011 0111 11 0 0000 0000 11
	 * 0101101111100000000011
	 * 0101 1011 1110 0000 0000 11 */

	outb(0x1A, 0x5B); /* while (inb(0x??) & ?) ; */

	busywait_usec(10000);

	outb(0x1A, 0xE0); /* while (inb(0x??) & ?) ; */

	busywait_usec(10000);

	outb(0x1A, 0x0F); /* two extra bits at end */

	busywait_usec(10000);

	outb(BEEP, 0); busywait_usec(10000);
	outb(BEEP, 1); busywait_usec(10000);
#endif

	printf("%s\r\n", version + 4);

	if ((inb(PA_DAT) & JUMPER) == 0)
		regenerate();

	silly();

	printf("%s\r\n", version + 4);
}

void
start()
{
	int i;
	long t;

	t = time();
	printf(" time=%ld\r\n", t);

	i = write(5, "test", 4);
	printf(" write(5)=%d\r\n", i);

	i = fork();
	if (i == 0) {
		/* copy uart 0 to screen, forever */

		write(5, "in child\n\r", 10);
		for (;;) {
			byte buf[1000];

			while ((i = read(0, buf, sizeof(buf))) > 0)
				write(5, buf, i);
		}
	}
	if (fork() == 0) {
		write(5, "in child 2\n\r", 12);
		kbd_reader();
	}
	printf(" out\r\n");
}

kbd_reader()
{
	byte c;
	int i;

	for (;;) {
		while (read(5, &c, 1) == 1) {
			switch (c) {
			default:
				write(1, &c, 1);
				break;

			case KF2:
				i = fork();
				if (i == -1)
					write(5, "no fork\n\r", 9);
				if (i == 0) {
					write(5, "child 3\n\r", 9);
#if 0
#asm
					push # 0x100     ; trap flag
					popf
					nop
#endasm
#endif
					_exit(0);
				}
				break;

			case KF3:
				{
					long tv[2];
					byte buf[100];

					gettimeofday(tv);
					i = sprintf(buf, "tod %ld.%06lu\r\n", tv[0], tv[1]);
					write(5, buf, i);
				}
				break;
			}
		}
	}
}

void
idle()
{
	for (;;) {
		fido = 10 * HZ;

		yield(); /* needed until task_0 moves stack from 0 */
	}
}

static word asic_timer_hz;

/* 256 Hz periodic */

void
regshow()
{
	byte buf[42];

	sprintf(buf, "%02X  %02X %02X  %02X %02X              ",
		inb(0x19),
		inb(0x1B), inb(0x1C),
		inb(PA_DAT), inb(PB_DAT));

	update_row(0, 8, buf);
}

void
tick()
{
	static word otim;

#if 0
	regshow();
#endif

	if (otim != timew) {
		otim = timew;

		uart_unwedge();

#if 0
		putc_2('c');
		putc_3('d');
		putc_4('e');
#endif
#if 0
		printf(" tik%x ", exchangew(0, &asic_timer_hz));
		printf(" %x %x ", inb(0x00), inb(0x02));

		outb(0x2C, (otim & 1) ? 0xFF : 0);
		outb(0x2D, (otim & 2) ? 0xFF : 0);

		outb(BEEP, (otim >> 3) & 1);
#endif
		outb(SERV, otim & 1);
	}
}

void
netintr()
{
}

/* int_0, int_1, int_2 and timer_2_int in boot.c */

void
int_3()
{
	printf(" int3 ");
}

void
timer_0_int()
{
	printf(" tmr0 ");
}

void
timer_1_int()
{
	printf(" tmr1 ");
}

void
timer_2_int()
{
	printf(" tmr2 ");
}

void
dma_0_int()
{
	printf(" dma0 ");
}

void
dma_1_int()
{
	printf(" dma1 ");
}

/* changes on PA monitored bits
 * lsbyte is current state,
 * msbyte shows changes */

void
pa_chg(w)
	word w;
{
	printf(" pa%x ", w);
}

/* changes on PB monitored bits, "rs232 handshake" signals
 * lsbyte is current state,
 * msbyte shows changes */

void
pb_chg(w)
	word w;
{
	printf(" pb%x ", w);
}

void
asic_timer_int()
{
	asic_timer_hz++;
}

/* ugh */

long
sys_badsys(a, b, c)
{
	printf("badsys(%d,%d,%d)\n", a, b, c);

	sys_exit(0x0200);
}

void
exception(exc)
{
	switch (exc) {
	case 1:
		printf("single step %04X:%04X\n\r",
			peekw(task->tsk_ss, task->tsk_sp + IREGS_CS),
			peekw(task->tsk_ss, task->tsk_sp + IREGS_IP));
		return;
	}

	printf("exception(%d)\n", exc);

	dump(exc, task->tsk_ss, task->tsk_sp);

	sys_exit(0x0300 | exc);
}

