/*
 * org 0xFFFF:0
 * length must be 16 bytes or less
 * moved later, by hand, into 0x3FFF0 in rom.bin
 *
 * FLAGS  F002 80C186/8 Initial Register State after RESET
 * IP     0000
 * CS     FFFF
 * DS     0000
 * ES     0000
 * SS     0000 nice, nmi will not trash anything valuable
 * RELREG 20FF
 * UMCS   FFFB
 */

#include "head.h"
#include "pcb.h"

#asm
	include asm.inc
	.text

	entry _reset
_reset:

	mov sp, # 0           ; SS:SP now 0:0

	; UCS: 256 kB, C0000 ... FFFFF. R=101: 1 waitstate, no RDY

	mov ax, # 0xC03D      ; XXX or 0xC03E or 0xC03F ?
	mov dx, # UMCS
	out dx, PCB_AX

	jmp far 0xC000:0x400  ; boot: in boot.c

	nop                   ; exactly 16 bytes

