
	.module ccir

	.include "iomap.inc"
	.include "cfg.inc"

	.area _BSS

prev:  .ds 1
ptr:   .ds 2

	.area _CODE

ccir_tones:
	.dw 1981, 1124, 1197, 1275, 1358  ; 0 ... 4
	.dw 1446, 1540, 1640, 1747, 1860  ; 5 ... 9
	.dw 2400,  930, 2247,  991, 2110  ; A ... E
	.dw 0                             ; F

_ccir_send::               ; void ccir_send(byte *s);
	pop de
	pop hl                 ; asciz string
	push hl
	push de

	xor a
	ld (_af_tx_timer), a   ; block background

	ld a, # 0xE            ; no previous
	ld (prev), a
	ld (ptr), hl           ; asciz string

	call _timer_mt_off
	call _CCIRC_on

	ld hl, # sender
	jp af_tx_start


sender:                    ; from tick via do_af_tx
	ld hl, (ptr)
	ld d, # 0              ; length
again:
	inc d                  ;  ++
	ld a, (hl)
	or a                   ; \0 ends string
	jp z, af_tx_sent
	inc hl
	cp # 'L
	jr z, again            ; L stretches next tone
	ld (ptr), hl

	ld hl, # prev          ; previous tone

	sub # '0               ; hex digit ?
	cp # 10
	jr c, 0$
	sub # 7                ; lowercase A-E not supported
0$:
	cp # 0xF
	jr c, 1$
	ld a, # 0xF            ; F or non-hex is pause
	ld (hl), # 0xE         ; no previous
1$:
	cp (hl)                ; repeat ?
	jr nz, 2$
	ld a, # 0xE
2$:
	ld (hl), a             ; previous tone updated

	ld hl, # ccir_tones
	add a, a               ; word index
	call add_hl_a

	ld a, (hl)
	inc hl
	ld h, (hl)
	ld l, a                ; Hz in HL

	push de                ; length

	push hl                ; pass HL for both routines
	call LPF_ccir
	pop hl
	call timer_mt

	pop de                 ; length
	dec d
	ld a, # 26             ; 100 msec by default
	ret z                  ; new count for _af_tx_timer in A
	dec d
	ld a, # 128            ; L, half a second
	ret z
	ld a, # 255            ; LL, one second
	ret

