
	P8x = 0
	L8x = 0
	L8M = 0
	L8TM = 0

	.include "asm_opts"

	.IF P8x
	.include "iomap_P8x.inc"
	.ENDIF

	.IF L8TM
	L8x = 1
	.include "iomap_L8TM.inc"
	.ENDIF

	.IF L8M
	L8x = 1
	.include "iomap_L8M.inc"
	.ENDIF



JPHL    = 0x10        ; restarts
DISABLE = 0x30

TMR_CLK = 4032000     ; Hz (except P8x TMR_2)

TICK_HZ = 256

TMR_INTTC   = 0x00    ; mode 0, intr on terminal cnt
TMR_ONESHOT = 0x02    ; mode 1, one shot
TMR_RATEGEN = 0x04    ; mode 2, rate generator
TMR_SQWAVE  = 0x06    ; mode 3, square wave
TMR_SWTRIGG = 0x08    ; mode 4, s/w triggered strobe
TMR_HWTRIGG = 0x0A    ; mode 5, h/w triggered strobe
TMR_LATCH   = 0x00
TMR_LSB     = 0x10    ; r/w counter LSB
TMR_MSB     = 0x20    ; r/w counter MSB
TMR_BOTH    = 0x30    ; r/w counter 16 b

; SIO registers

RR0_TBE      = 0x04
RR1_ALL_SENT = 0x01

WR0_RESET_TXINT  = 0x28
WR0_RESET_ESCINT = 0x10
WR0_ERROR_RESET  = 0x30

WR1_ESCINT_ENB			= 0x01
WR1_TXINT_ENB			= 0x02
WR1_STATUS_VECTOR		= 0x04
WR1_RXINT_DISABLE		= 0x00
WR1_INT_1STC			= 0x08
WR1_INT_ALLC			= 0x10
WR1_INT_ALLC_PNS		= 0x18
WR1_WAITREADY_RT		= 0x20
WR1_WAITREADY_FN		= 0x40
WR1_WAITREADY_ENB		= 0x80

WR3_RX_ENB				= 0x01
WR3_SYNCLOAD_INHIBIT	= 0x02
WR3_ADDRESS_SEARCH_MODE	= 0x04
WR3_RXCRC_ENB			= 0x08
WR3_ENTER_HUNT			= 0x10
WR3_AUTO_ENABLES		= 0x20
WR3_5BIT_RX				= 0x00
WR3_6BIT_RX				= 0x40
WR3_7BIT_RX				= 0x80
WR3_8BIT_RX				= 0xc0

WR4_PARITY_ENB			= 0x01
WR4_PARITY_ODD			= 0x00
WR4_PARITY_EVEN			= 0x02
WR4_SYNC_MODES			= 0x00
WR4_1STOPBIT			= 0x04
WR4_15STOPBIT			= 0x08
WR4_2STOPBIT			= 0x0c
WR4_8BITSYNC			= 0x00
WR4_16BITSYNC			= 0x10
WR4_SDLC_MODE			= 0x20
WR4_EXTSYNC				= 0x30
WR4_X1_CLK				= 0x00	; 153600 bd, but...
WR4_X16_CLK				= 0x40	;   9600 bd
WR4_X32_CLK				= 0x80	;   4800 bd
WR4_X64_CLK				= 0xc0	;   2400 bd

WR5_TXCRC_ENB			= 0x01
WR5_RTS					= 0x02
WR5_CCITT_CRC			= 0x00
WR5_CRC16_CRC			= 0x04
WR5_TX_ENB				= 0x08
WR5_SEND_BREAK			= 0x10
WR5_5BIT_TX				= 0x00
WR5_7BIT_TX				= 0x20
WR5_6BIT_TX				= 0x40
WR5_8BIT_TX				= 0x60
WR5_DTR					= 0x80


; matches CU53 hw

LED_AVAIL    = 7     ; no connect
LED_CALL     = 6
LED_ROAM     = 5
LED_KEYLIGHT = 4
LED_SERV     = 3
LED_ON       = 2
LED_LCDLIGHT = 1
LED_BRIGHT   = 0     ; no connect in CU58AF


