
; audio is unsigned bytes, 4000 Hz
; each sample is done 4 times to get full range volume
; P8N loop 1008 T
; P8E loop 2016 T

	.module silly

	.include "iomap.inc"

	.area _CODE

_silly::

	.IF L8M

	ret

	.ELSE

	rst DISABLE              ; from now on.

	.IF P8x

	ld a, (_out_2)
	or # O2_ROM0 | O2_ROMA14
	out (OUT_2), a           ; rom bank from last 16kB of ROM0

	ld hl, # _rom_bank

	endp = 0xC0

	.ENDIF

	.IF L8TM

	ld a, (_bank)
	or # BNK_ROM0A15
	out (BANK), a            ; second 32kB of ROM0

	ld hl, # 0x4000

	endp = 0x80

	.ENDIF

	ld a, # TMR_SEL_MT | TMR_LSB | TMR_INTTC
	out (TMR_CTRL), a
top:
	call one
	inc de                   ; dummy
	ld a, # 0                ; dummy
	nop                      ; dummy
	jp .+3                   ; dummy

	call one
	inc de                   ; dummies
	ld a, # 0
	nop
	jp .+3

	call one
	inc de                   ; dummies
	ld a, # 0
	nop
	jp .+3

	call one                 ; 17/18
	inc hl                   ;  6/7
	ld a, # endp             ;  7/8
	cp h                     ;  4/5
	jp nz, top               ; 10/11 ends at 0xC000

	; restore rom bank

	.IF P8x

	ld a, (_out_2)
	out (OUT_2), a

	.ENDIF

	.IF L8TM

	ld a, (_bank)
	out (BANK), a

	.ENDIF

	jp _restore              ; RET


one:
	ld a, (hl)               ;  7/8  audio[]
	out (TMR_MT), a          ; 11/12 sample
	out (WDOG), a            ; 11/12

	ex (sp), ix              ; 23/25 dummies
	ex (sp), ix              ; 23/25
	ex (sp), ix              ; 23/25
	ex (sp), ix              ; 23/25

	jp .+3                   ; 10/11
	jp .+3                   ; 10/11
	jp .+3                   ; 10/11
	jp .+3                   ; 10/11
	ld a, # 0                ;  7/8

	ld a, (_logic)           ; 13/14
	cp # 0                   ;  7/8
	call z, burn_more        ; 10/18 extra needed for P8E
	ret                      ; 10/11


burn_more:
	ld a, # 10               ; /8
2$:
	dec a                    ; /50
	jp nz, 2$                ; /110

	jp .+3                   ; /11
	jp .+3                   ; /11
	jp .+3                   ; /11
	ld a, # 0                ; /8
	ret                      ; /11

	.ENDIF  ; P8x or L8TM

silly_end::
